import App
import MissionLib

pGame = App.Game_GetCurrentGame()
pEpisode = pGame.GetCurrentEpisode()
pMission = pEpisode.GetCurrentMission()

g_pMissionDatabase 	= None
g_pFelix		= None
g_pBrex			= None


# Here we Count the Shuttles in our Bay
# Basicly copied from the Shuttle Launching Framework by sleight42 (AddLaunchButtons() in LaunchShipHandlers.py)
def GetShuttlesInBay():
	pCarrier = ftb.ShipManager.GetShip( MissionLib.GetPlayer())
	pLaunchers = pCarrier.GetLaunchers()
	numTypes = len( pLaunchers)
	for index in range( numTypes):
		launchType = pLaunchers[index].GetLaunchType()
		numLaunches =  pLaunchers[index].GetNumLaunches( launchType)
		firstlaunchType = launchType
		
		launchType = None
		
		while (launchType != firstlaunchType):
			launchType = pLaunchers[index].NextLaunchType()
			if (launchType != firstlaunchType):
				numLaunches =  numLaunches + pLaunchers[index].GetNumLaunches( launchType)

	return numLaunches


#How much Shuttles can we get in our Bay?
def GetMaxShuttlesInBay(pEvent):
	pTractorProjector	= App.TractorBeamProjector_Cast(pEvent.GetSource())
	pTractorSystem		= App.TractorBeamSystem_Cast(pTractorProjector.GetParentSubsystem())
	
	# Get the name of the ship that fired
	pShip = pTractorSystem.GetParentShip()
	if (pShip == None):
		return
	sFiringShipName = pShip.GetName()
	
	OurShipName = pShip.GetShipProperty().GetShipName()

	# Carrier Plugin to be used
	import Custom.Carriers.ShuttleBayInfos
	return Custom.Carriers.ShuttleBayInfos.MaxShuttlesInBay(OurShipName)


################################################################################
##	TractorTargetDocked()
##
##	Event handler called when tractor target has docked with ship.
##
##	Args:	pTGObject	- The TGObject object
##			pEvent		- The event that was sent to the object
##
##	Return:	None
################################################################################
# Defiant....
def TractorTargetDocked(pTGObject, pEvent):
	print("Calling TractorTargetDocked()")

	# Get some Var for the Audio Lines
	global g_pMissionDatabase
	global g_pFelix
	
	pBridge = App.g_kSetManager.GetSet("bridge")
	g_pMissionDatabase 	= pMission.SetDatabase("data/TGL/QuickBattle/ReturnShuttles.tgl")
	g_pFelix	= App.CharacterClass_GetObject(pBridge, "Tactical")

	# Get the object that was docked and it's name
	pObject	= App.ShipClass_Cast(pEvent.GetObjPtr())
	if (pObject == None):
		return
	pShip	= App.ShipClass_Cast(pEvent.GetDestination())
	if (pShip == None):
		return
	sShipName	= pShip.GetName()
	sName 	= pObject.GetName()

	# Rremove the Object from the set
	# and increase the captured count
	pObject.SetDeleteMe(1)
	#launcher.AddLaunchable( sName, "QuickBattle.QuickBattleFriendlyAI", 2)
	#Name Error: Launcher
	
	if (sName[:3] == "Ret"):
		if (sShipName == "Player"):
			#print("Play the audio line that will let the player know pod is docked")
			pSequence = App.TGSequence_Create()
			pFelixLine	= App.CharacterAction_Create(g_pFelix, App.CharacterAction.AT_SAY_LINE, "E6M2PodDocked", "Captain", 1, g_pMissionDatabase)
			pSequence.AppendAction(pFelixLine, 2) #2 second delay
			pSequence.Play() 
		
	print("Tractor Target Docked is finished and done")

################################################################################
##	TractorBeamOn()
##
##	Event handler called when tractor beam starts hitting a target.  Checks to
##	see if the target is a pod and starts docking behavior if it is.
##
##	Args:	TGObject	- The TGObject object.
##			pEvent		- The event that was sent.
##
##	Return:	None
################################################################################
#Defiant...
def TractorBeamOn(TGObject, pEvent):
	# Get the event destination (the thing hit by tractor beam)
	print("Tractor Beam on")

	# Get some Var for the Audio Lines
	global g_pMissionDatabase
	global g_pFelix
	global g_pBrex
	pBridge 		= App.g_kSetManager.GetSet("bridge")
	g_pMissionDatabase 	= pMission.SetDatabase("data/TGL/QuickBattle/ReturnShuttles.tgl")
	g_pFelix		= App.CharacterClass_GetObject(pBridge, "Tactical")
	g_pBrex			= App.CharacterClass_GetObject(pBridge, "Engineer")
	ShuttleBaySize		= None
	MaxShuttlesInBay	= None
	
	pShip = App.ShipClass_Cast(pEvent.GetDestination())
	if (pShip == None):
		#print("failed")
		return
		
	sTargetName = pShip.GetName()
	#print("Target Ship in Tractor is: " + sTargetName)
	
	#Lets try to get the size of our Target ship
	TargetHullSize = pShip.GetHull().GetRadius()
	#print("Size of the Target:")
	#print(TargetHullSize)

	# Get the tractor beam system that fired so we
	# can set it's behavior.
	pTractorProjector	= App.TractorBeamProjector_Cast(pEvent.GetSource())
	pTractorSystem		= App.TractorBeamSystem_Cast(pTractorProjector.GetParentSubsystem())
	
	# Get the name of the ship that fired
	pShip = pTractorSystem.GetParentShip()
	if (pShip == None):
		return
	sFiringShipName = pShip.GetName()
	
	OurShipName = pShip.GetShipProperty().GetShipName()
	#print("Firing Ship Name: " + OurShipName)	

	# Carrier Plugin to be used
	import Custom.Carriers.ShuttleBayInfos

	#and the size of our Shuttle Bay
#	ShuttleBaySize = pShip.GetShuttleBay.GetRadius() #or something like that...later!
	ShuttleBaySize = Custom.Carriers.ShuttleBayInfos.ShuttleBaySize(OurShipName)
	#print("Size of our Shuttle Bay:");
	if (ShuttleBaySize == None):
		#print("None set")
		return
	#print(ShuttleBaySize)
	
	print("Max Shuttles we can carry:");
	MaxShuttlesInBay=GetMaxShuttlesInBay(pEvent)
	if (MaxShuttlesInBay == None):
		print("None set")
		return
	print(MaxShuttlesInBay)
	
	ShuttlesInBay=GetShuttlesInBay()
	print("Shuttles currently in Bay:")
	print(ShuttlesInBay)

	# See if the ship is small enough to fit into out Bay
	if (TargetHullSize < ShuttleBaySize):
		#print("Target is small enough to get in our Bay")

		# Test if we got enough space in our Bay
		if ( MaxShuttlesInBay > ShuttlesInBay ):
			print("There is enough space left in our Bay")
			if (pTractorSystem != None):
				# set the tractor beam to pull in and dock the pod
				#print("Target will be docked")
				pTractorSystem.SetMode(pTractorSystem.TBS_DOCK_STAGE_1)
		else:
			print("Sorry: No Space left")
			
		if (sTargetName[:3] == "Ret"):
			# It's a pod
			#print("Playing Brex's .attempting to dock pod. line")	
			pBrexLine = App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_SAY_LINE, "E6M2FelixDockPod", "Captain", 1, g_pMissionDatabase)
			pBrexLine.Play()
		else:
			# It's not a Pod
			#print("Playing Brex's attempting to dock line")	
			pBrexLine = App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_SAY_LINE, "FelixDockShip", "Captain", 1, g_pMissionDatabase)
			pBrexLine.Play()

	# We're done.  Let any other handlers for this event handle it.
	print("Tractor beam on finished")
	TGObject.CallNextHandler(pEvent)
	
#print("Loading Defiants event Handlers to get the Shuttles back")
# Tractor beam target docked event
App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_TRACTOR_TARGET_DOCKED, pMission, __name__+".TractorTargetDocked")
# Tractor beam starts hitting event
App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_TRACTOR_BEAM_STARTED_HITTING, pMission, __name__+".TractorBeamOn")
